# encoding: utf-8

require 'spec_helper'

describe Relation::Header, '#each' do
  subject { object.each { |tuple| yields << tuple } }

  let(:attribute) { Attribute::Integer.new(:id)      }
  let(:object)    { described_class.new([attribute]) }
  let(:yields)    { []                               }

  it_should_behave_like 'an #each method'

  it 'yields only attributes' do
    subject
    yields.each { |attribute| expect(attribute).to be_kind_of(Attribute) }
  end

  it 'yields each attribute' do
    expect { subject }.to change { yields.dup }
      .from([])
      .to([attribute])
  end
end

describe Relation::Header do
  subject { object.new }

  let(:object) { described_class }

  it { should be_kind_of(Enumerable) }

  it 'case matches Enumerable' do
    expect(Enumerable === subject).to be(true)
  end
end
