# encoding: utf-8

require 'spec_helper'

describe Relation, '#materialize' do
  subject { object.materialize }

  let(:header) { Relation::Header.coerce([[:id, Integer]])                                   }
  let(:object) { described_class.new(header, LazyEnumerable.new([[1]])).sort_by { |r| r.id } }

  before do
    expect(object).to be_kind_of(described_class)
  end

  it { should be_instance_of(Relation::Materialized) }

  its(:header) { should be(header) }

  its(:directions) { should == header }

  it 'returns an equivalent relation to the unmaterialized operation' do
    should == object
  end
end
